vsg: vsg::QuadGroup Class Reference

vsg 1.1.9 VulkanSceneGraph library |

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
vsg::QuadGroup Class Reference

`#include <QuadGroup.h>`

Inheritance diagram for vsg::QuadGroup:
[legend]
Collaboration diagram for vsg::QuadGroup:
[legend]

## Public Types
using | Children = std::array<ref_ptr<vsg::Node>, 4>

## Public Member Functions
| QuadGroup (const QuadGroup &rhs, const CopyOp &copyop={})
ref_ptr< Object > | clone (const CopyOp &copyop={}) const override
int | compare (const Object &rhs) const override
| compare two objects, return -1 if this object is less than rhs, return 0 if it's equal, return 1 if rhs is greater,
void | traverse (Visitor &visitor) override
void | traverse (ConstVisitor &visitor) const override
void | traverse (RecordTraversal &visitor) const override
void | read (Input &input) override
void | write (Output &output) const override
Public Member Functions inherited from vsg::Inherit< Node, QuadGroup >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
void | accept (Visitor &visitor) override
void | accept (ConstVisitor &visitor) const override
void | accept (RecordTraversal &visitor) const override
Public Member Functions inherited from vsg::Node
| Node (const Node &rhs, const CopyOp &copyop={})
Public Member Functions inherited from vsg::Inherit< Object, Node >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
void | accept (Visitor &visitor) override
void | accept (ConstVisitor &visitor) const override
void | accept (RecordTraversal &visitor) const override
Public Member Functions inherited from vsg::Object
| Object (const Object &object, const CopyOp &copyop={})
Object & | operator= (const Object &)
template<class T>
T * | cast ()
template<class T>
const T * | cast () const
void | ref () const noexcept
void | unref () const noexcept
void | unref_nodelete () const noexcept
unsigned int | referenceCount () const noexcept
template<typename T>
void | setValue (const std::string &key, const T &value)
void | setValue (const std::string &key, const char *value)
| specialization of setValue to handle passing C strings
template<typename T>
bool | getValue (const std::string &key, T &value) const
| get specified value type, return false if value associated with key is not assigned or is not the correct type
void | setObject (const std::string &key, ref_ptr< Object > object)
| assign an Object associated with key
Object * | getObject (const std::string &key)
| get Object pointer associated with key, return nullptr if no object associated with key has been assigned
const Object * | getObject (const std::string &key) const
| get const Object pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
T * | getObject (const std::string &key)
| get object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const T * | getObject (const std::string &key) const
| get const object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< Object > | getRefObject (const std::string &key)
| get ref_ptr<Object> associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< const Object > | getRefObject (const std::string &key) const
| get ref_ptr<const Object> pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
ref_ptr< T > | getRefObject (const std::string &key)
| get ref_ptr<T> of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const ref_ptr< const T > | getRefObject (const std::string &key) const
| get ref_ptr<const T> of specified type associated with key, return nullptr if no object associated with key has been assigned
void | removeObject (const std::string &key)
| remove meta object or value associated with key
Auxiliary * | getOrCreateAuxiliary ()
Auxiliary * | getAuxiliary ()
const Auxiliary * | getAuxiliary () const

## Static Public Member Functions
template<class N, class V>
static void | t_traverse (N &node, V &visitor)
Static Public Member Functions inherited from vsg::Inherit< Node, QuadGroup >
static ref_ptr< QuadGroup > | create (Args &&... args)
static ref_ptr< QuadGroup > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Node
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_NODES_OBJECTS
static void | operator delete (void *ptr)
Static Public Member Functions inherited from vsg::Inherit< Object, Node >
static ref_ptr< Node > | create (Args &&... args)
static ref_ptr< Node > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Object
static ref_ptr< Object > | create ()
static ref_ptr< Object > | create_if (bool flag)
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_AFFINTY_OBJECTS
static void | operator delete (void *ptr)

## Public Attributes
Children | children

## Additional Inherited Members
Protected Member Functions inherited from vsg::Object
virtual void | _attemptDelete () const
void | setAuxiliary (Auxiliary *auxiliary)

## Detailed Description

QuadGroup is a specialized group node that manages 4 children, designed to minimize the CPU overhead of traversing quad trees. The number of children is fixed and all children are assumed to be set before traversal of the scene graph, failure to set up correctly will lead to memory faults, this is a deliberate choice as any checks for pointer validity will incur CPU overhead.

## Member Function Documentation

## ◆ clone()

ref_ptr< Object > vsg::QuadGroup::clone | ( | const CopyOp & | copyop = {} | ) | const
| inlineoverridevirtual

clone this object using CopyOp's duplicates map to decide whether to clone or to return the original object. The default clone(CopyOp&) implementation simply returns ref_ptr<> to this object rather attempt to clone.

Reimplemented from vsg::Node.

## ◆ compare()

int vsg::QuadGroup::compare | ( | const Object & | rhs | ) | const
| overridevirtual

compare two objects, return -1 if this object is less than rhs, return 0 if it's equal, return 1 if rhs is greater,

Reimplemented from vsg::Inherit< Node, QuadGroup >.

## ◆ read()

void vsg::QuadGroup::read | ( | Input & | input | ) |
| overridevirtual

Reimplemented from vsg::Object.

## ◆ traverse() [1/3]

void vsg::QuadGroup::traverse | ( | ConstVisitor & | visitor | ) | const
| inlineoverridevirtual

Reimplemented from vsg::Object.

## ◆ traverse() [2/3]

void vsg::QuadGroup::traverse | ( | RecordTraversal & | visitor | ) | const
| inlineoverridevirtual

Reimplemented from vsg::Object.

## ◆ traverse() [3/3]

void vsg::QuadGroup::traverse | ( | Visitor & | visitor | ) |
| inlineoverridevirtual

Reimplemented from vsg::Object.

## ◆ write()

void vsg::QuadGroup::write | ( | Output & | output | ) | const
| overridevirtual

Reimplemented from vsg::Object.

The documentation for this class was generated from the following file:

- include/vsg/nodes/QuadGroup.h